// -*- C++ -*- //

#ifndef ALGOWIN_H
#define ALGOWIN_H

class AlgoWin;

#include <all_include.h>
//#include <mapstorage.h>
#include <algobox.h>
#include <libgnomecanvasmm.h>
#include <libgnomecanvasmm/polygon.h>

class MapStorage;

enum {GENERAL, KRUSKAL, ALGO_NUM}; // algorithm IDs;

class AlgoWin : public Gtk::Window
{
private:
  AlgoBox * ab;
  Gtk::Button * runbutton;
  Gtk::Button * closebutton;

protected:
  sigc::signal<void, AlgoWin *> signal_closed;  
  sigc::signal<void, AlgoWin *, std::string> signal_maplist_need;  
  sigc::signal<void, std::string, bool> signal_newmapwin_need;  

public:
  bool closeIfEscapeIsPressed(GdkEventKey* e);

  sigc::signal<void, AlgoWin *> signal_closing();
  sigc::signal<void, AlgoWin *, std::string> signal_maplist_needed();
  sigc::signal<void, std::string, bool> signal_newmapwin_needed(){return signal_newmapwin_need;};  

  void emit_tab_change(std::string);
  void emit_new_map_signal(std::string tabname, bool itisedge){signal_newmapwin_need.emit(tabname, itisedge);};

  AlgoWin(int, std::vector<std::string>);

  void update_tablist(std::vector<std::string> tabnames);
  void update_maplist(MapStorage *);

  void on_hide();
};
#endif //ALGOWIN_H
